<template>
  <!-- 物资领用信息 -->
  <div>
    <el-dialog
      :close-on-click-modal="false"
      :title="'物资领用信息'"
      :visible.sync="showFormDia"
      width="60%"
      :before-close="handleClose"
      custom-class="bbsl-location-dialog"
      top="8vh"
    >
      <div class="bbsl-scroll-pane">
        <el-form
          ref="formInfo"
          class="bbsl-scroll-form-spare"
          :model="params"
          label-width="80px"
        >
          <!-- <p id="step1" class="from-title">
            <i class="el-icon-info" />
            <span>基本信息</span>
          </p>
          <el-row>
            <el-col :span="8">
              <el-form-item label="领用人" prop="applicationDept">
                <el-select
                  v-model="params.fortheUser"
                  clearable
                  filterable
                  allow-create
                  style="width: 100%"
                  placeholder="请选择领用人员"
                  @change="userChange"
                >
                  <el-option
                    v-for="item in userSelectOptions"
                    :key="item.id"
                    :label="item.fullname"
                    :value="item.id"
                  >
                    <span style="float: left">{{ item.fullname }}</span>
                    <span
                      style="
                                                float: right;
                                                color: #8492a6;
                                                font-size: 13px;
                                            "
                      >{{ item.orgName }}</span
                    >
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="领用部门" prop="applicationDept">
                <el-input v-model="params.fortheOrgName" readonly />
              </el-form-item>
            </el-col>
          </el-row> -->
          <p id="step1" class="from-title">
            <i class="el-icon-info" />
            <span>领用明细</span>
          </p>

          <el-table
            :data="purchasingDetailList"
            style="width: 100%"
            :height="300"
            highlight-current-row
          >
            <el-table-column label="序号" type="index" width="55" />
            <el-table-column label="品名" min-width="120"  prop="name" />
            <el-table-column label="规格型号" min-width="80" prop="model" />
            <el-table-column label="单位" width="80" prop="unit" />
            <el-table-column
              v-if="application && application.status != 3"
              label="库存数量"
              prop="remainingQuantity"
              width="100"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.remainingQuantity || 0 }}</span>
              </template>
            </el-table-column>
            <el-table-column
              label="领用数量"
              prop="quantity"
              width="150"
            >
              <template slot-scope="scope">
                <el-input-number
                  v-if="application && application.status != 3"
                  v-model="scope.row.quantity"
                  controls-position="right"
                  size="large"
                  style="width: 100%"
                />
                <span v-else>{{ scope.row.quantity }}</span>
              </template>
            </el-table-column>
            <!-- <el-table-column label="备注" prop="memo">
              <template slot-scope="scope">
                <div v-if="application && application.status != 3">
                  <el-input
                    v-model="scope.row.memo"
                    maxlength="50"
                    size="mini"
                  />
                </div>
                <span v-else>{{ scope.row.memo }}</span>
              </template>
            </el-table-column> -->
            <el-table-column
              v-if="applicationStart == false"
              label="操作"
              width="60"
            >
              <template slot-scope="scope">
                <!-- <el-tooltip
                  class="item"
                  effect="dark"
                  content="该物资库存为0，不可领用！"
                  placement="top"
                >

                </el-tooltip> -->
                <el-button
                  size="mini"
                  type="danger"
                  circle
                  icon="el-icon-close"
                  @click="deleteDetail(scope.$index)"
                />
              </template>
            </el-table-column>
          </el-table>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button
          v-show="applicationStart == false"
          type="primary"
          @click="handleSave"
          v-if="application && application.status != 3"
          >出库</el-button
        >
        <el-button @click="handleClose">取 消</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import materialOutWarehouseManage from '@/api/manager/material/materialOutWarehouseManage.js'
import CommonApi from '@/views/Manage/CommonApi.js'
export default {
  name: 'materialOutWarehouseManageDialog',
  data() {
    return {
      applicationStart: false,
      title: '新增',
      showFormDia: false,
      purchasingDetailList: [],
      params: {
        fortheOrg: '',
        // fortheOrgName: '',
        purchasingId: '',
        list: []
      },
      userSelectOptions: [],
      application: null
    }
  },
  created() {
    this.commonApiData()
  },
  methods: {
    deleteDetail(index) {
      this.purchasingDetailList.splice(index, 1)
    },
    //领用人
    userChange(v, s) {
      const vobj = this.userSelectOptions.find(u => {
        return u.id === v
      })
      if (vobj) {
        this.params.applicantName = vobj.fullname
      }
    },
    commonApiData() {
      CommonApi.loadSelectOptions(
        {
          name: 'manageCommonService.getAllUsers',
          query: '96240625-934F-490B-8AA6-0BC775B18468'
        },
        res => {
          this.userSelectOptions = res
        }
      )
    },
    edit() {},
    recipients(application) {
      this.application = application
      const userinfo = this.$store.state.user.currentUserDetail
      this.params.fortheOrg = userinfo.org[0].orgId
      //   this.params.fortheOrgName = userinfo.org[0].orgName
      //   this.params.fortheUser = userinfo.user.id
      this.params.purchasingId = this.application.id
      this.showFormDia = true
      this.loadDetail()
    },
    detail(application) {
      console.log(application, 'application')
      //   this.params.fortheUser = application.applicant
      //   this.params.fortheOrgName = application.applicationDeptName
      this.application = application
      if (application.status == '2') {
        this.applicationStart = true
      }

      this.showFormDia = true
      this.loadDetail()
    },
    loadDetail() {
      materialOutWarehouseManage.loadMaterialDetail(
        this.application.id,
        res => {
          if (res && res.state) {
            this.purchasingDetailList = res.value
            console.log(res.value);
            
          }
        }
      )
    },
    handleSave() {
      const userinfo = this.$store.state.user.currentUserDetail
      let list = []
      this.purchasingDetailList.forEach(item => {
        list.push({
          materialId: item.materialInfoId,
          materialName: item.name,
          model: item.model,
          unit: item.unit,
          quantity: item.quantity,
          fortheOrg: userinfo.org[0].orgId
          //   fortheUser: userinfo.user.id
        })
      })
      this.params.list = list
      materialOutWarehouseManage.recipients(this.params, res => {
        if (res.state) {
          this.$notify({
            type: 'success',
            message: this.title + '成功',
            duration: 2000
          })
          this.$parent.loadData()
          this.handleClose()
        } else {
          this.$message.warning(response.message)
        }
      })
    },
    handleClose() {
      this.params = {
        fortheOrg: '',
        // fortheOrgName: '',
        purchasingId: '',
        list: []
      }
      this.$refs.formInfo.clearValidate()
      this.purchasingDetailList = []
      this.title = '新增'
      this.showFormDia = false
      this.applicationStart = false
    }
  }
}
</script>
<style lang="scss" scoped>
.redBull {
  border: 1px solid red;
}
.bbsl-scroll-form-spare {
  width: calc(100% - 20px);
  // height: calc(95vh - 320px);
  overflow-y: auto;
  padding: 0 10px;
}
</style>
